Main Page Namespace List Class Hierarchy Alphabetical List Compound List Namespace Members Compound Members Related Pages

# PluginClass::ClassDescC Class Reference

Plugin Class Descriptor class. More...

`#include <ClassDescC.h>`

List of all members.

## Public Methods

- ClassDescC ()
- virtual ~ClassDescC ()
- virtual void* create () = 0
- virtual PajaTypes::int32 get_classtype () const = 0
- virtual ClassIdC get_classid () const = 0
- virtual SuperClassIdC get_super_classid () const = 0
- virtual const char* get_name () const = 0
- virtual const char* get_desc () const = 0
- virtual const char* get_author_name () const = 0
- virtual const char* get_copyright_message () const = 0
- virtual const char* get_url () const = 0
- virtual const char* get_help_filename () const = 0
- virtual PajaTypes::uint32 get_ext_count () const = 0
- virtual const char* get_ext ( PajaTypes::uint32 ui32Index ) const = 0
- virtual bool check_device_support ( PajaSystem::DeviceContextC* pContext ) = 0

## Detailed Description

Plugin Class Descriptor class.

Class descriptors provide the system information about the plugin classes in the DLL. Developer creates a class descriptor by deriving a class from ClassDescC and implementing the methods

This class is implemented by the plugin.

## Constructor & Destructor Documentation

ClassDescC ( | )

| Default constructor.

~ClassDescC ( | )`[virtual]`

| Default destructor.

## Member Function Documentation

bool check_device_support ( | PajaSystem::DeviceContextC * pContext )`[pure virtual]`

  | Check plugin's device support. Parameters:
  pContext | Pointer to the device context containing all the supported interfaces.
Returns: True if device context holds a device interface the plugin class supports. This function is called by the system at load time to check if this plugin class can be used with the current devices, such as OpenGL or software rendering. To check if the interface the plugin class uses is available, the method should query it. If query_interface methods returns an interface then it exists. Otherwise the interface is not supported. Example Implementation:
                bool
                TGAImportDescC::check_device_support( DeviceContextC* pContext )
                {
                    if( pContext->query_interface( INTERFACE_OPENGL ) )
                        return true;
                    return false;
                }

void * create ( | )`[pure virtual]`

| Demopaja calls this method when it needs new instance of the plugin class. The plugin is responds by allocating a new insance of its plugin class. The instace should be derived from DataBlockI interface, which has the release method for deleting the instance. Example Implementation:
                void*
                TGAImportDescC::create()
                {
                    return (void*)TGAImportC::create_new();
                }

const char * get_author_name ( | ) const`[pure virtual]`

| Returns the short description of the developer of the plugin class as NULL terminated string. Example Implementation:
                const char*
                TGAImportDescC::get_author_name() const
                {
                    return "Mikko \"memon\" Mononen";
                }

ClassIdC get_classid ( | ) const`[pure virtual]`

| Returns unique class ID of the plugin class. Each plugin class must have unique class ID. The Demopaja system will identify the plugin classes (Importers and Effects) by its class ID. If two classes conflict the system will use the first class it finds. Use the random class ID generator provided with the SDK to generate new class IDs to avoid conflicts. This ID is for per class, you don't have to create new ID for every instance.

PajaTypes::int32 get_classtype ( | ) const`[pure virtual]`

| Returns the type of the plugin. The return value can be either CLASS_TYPE_EFFECT or CLASS_TYPE_FILEIMPORT depending on the plugin class' type. Both values are defined in the ClassDescC.h.

const char * get_copyright_message ( | ) const`[pure virtual]`

| Returns copyright message of the plugin class as NULL terminated string. Example Implementation
                const char*
                TGAImportDescC::get_copyright_message() const
                {
                    return "Copyright (c) 2000 Moppi Productions";
                }

const char * get_desc ( | ) const`[pure virtual]`

| Returns description of the plugin class as NULL terminated string. Example Implementation:
                const char*
                TGAImportDescC::get_desc() const
                {
                    return "Importer for Targa (.TGA) images";
                }

const char * get_ext ( | PajaTypes::uint32 ui32Index ) const`[pure virtual]`

  | Returns the extension of specified index as a NULL terminated string. Parameters:
  ui32Index | A zero based index of the extension string get get.
The extension can be any length, but it should not include the leading ".". Example Implementation:
                const char*
                TGAImportDescC::get_ext( uint32 ui32Index ) const
                {
                    if( ui32Index == 0 )
                        return "tga";
                    else if( ui32Index == 1 )
                        return "vda";
                    else if( ui32Index == 2 )
                        return "icb";
                    else if( ui32Index == 3 )
                        return "vst";
                    return 0;
                }

PajaTypes::uint32 get_ext_count ( | ) const`[pure virtual]`

| Returns number of file extensions used by the plugin class. This information is only used with the importer and exporter plugins. Effect plugin class descriptors should return zero. Example Implementation:
                uint32
                TGAImportDescC::get_ext_count() const
                {
                    return 4;
                }

const char * get_help_filename ( | ) const`[pure virtual]`

| Returns the path name to the help file of the plugin class. This path name will be used to load the help file of a plugin class to be shown in the Help Viewer. The help files has to be in HTML format. The path is relative to the Demopaja plugin directory. Example Implementation:
                const char*
                TGAImportDescC::get_url() const
                {
                    return "TGAImport.html";
                }

const char * get_name ( | ) const`[pure virtual]`

| Returns the name of the plugin class as NULL terminated string. The name of the plugin class should be as descriptive as possible. This name is used all over the user interface so make it short. Name of below 15 characters is good. Example Implementation:
                const char*
                TGAImportDescC::get_name() const
                {
                    return "Targa Image";
                }

SuperClassIdC get_super_classid ( | ) const`[pure virtual]`

| Returns super class ID of the plugin class. This method returns system defined constant which describes the class this plugin class is derived from. For example all effects returns SUPERCLASS_EFFECT (defined in EffectI.h).

const char * get_url ( | ) const`[pure virtual]`

| Returns the URL of the developers homepage (or e-mail address) as NULL terminated string. This information will be used in the About Plugins dialog to forward user to the homepage of the plugin. Example Implementation:
                const char*
                TGAImportDescC::get_url() const
                {
                    return "http://moppi.inside.org/demopaja/";
                }

The documentation for this class was generated from the following file:

- ClassDescC.h